package org.mineacademy.nms.specific.enchant;

import org.bukkit.enchantments.Enchantment;
import org.mineacademy.fo.enchant.NmsEnchant;
import org.mineacademy.fo.enchant.SimpleEnchantment;

import net.minecraft.server.v1_8_R3.EnchantmentSlotType;
import net.minecraft.server.v1_8_R3.MinecraftKey;

public final class CustomEnchant_v1_8 extends net.minecraft.server.v1_8_R3.Enchantment implements NmsEnchant {

	private static int startId = 63;

	private final SimpleEnchantment simpleEnchantment;

	public CustomEnchant_v1_8(final SimpleEnchantment enchant) {
		super(startId++, new MinecraftKey(enchant.getNamespacedName()), 1, EnchantmentSlotType.ALL);

		this.simpleEnchantment = enchant;
		this.simpleEnchantment.setLegacyId(this.id);
	}

	@Override
	public void register() {
		// Done for you in super()
	}

	@Override
	public Enchantment toBukkit() {
		return Enchantment.getById(this.id);
	}

	@Override
	public int getStartLevel() {
		return this.simpleEnchantment.getStartLevel();
	}

	@Override
	public int getMaxLevel() {
		return this.simpleEnchantment.getMaxLevel();
	}

	@Override
	public int a(final int level) {
		return this.simpleEnchantment.getMinCost(level);
	}

	@Override
	public int b(final int level) {
		return this.simpleEnchantment.getMaxCost(level);
	}

	@Override
	public boolean canEnchant(final net.minecraft.server.v1_8_R3.ItemStack item) {
		return this.simpleEnchantment.canEnchantItem(
				org.bukkit.craftbukkit.v1_8_R3.inventory.CraftItemStack.asBukkitCopy(item)) || super.canEnchant(item);
	}

	@Override
	public boolean a(final net.minecraft.server.v1_8_R3.Enchantment other) {
		final Enchantment bukkitEnch = Enchantment.getById(other.id);

		return bukkitEnch == null || !this.simpleEnchantment.conflictsWith(bukkitEnch);
	}
}